package cn.spatiotemporal.core.async;

import lombok.Getter;
import lombok.NoArgsConstructor;

/**
 * 异步处理阶段
 * @author marquis
 *
 */
@Getter
@NoArgsConstructor 
public enum AsyncProcessPhase {
	
	PRE_CALL("准备异步调用指令"),
	CALL_MSG_SENT("调用指令已发送"),
	CALL_MSG_RECIEVED("调用指令已接收"),
	CALL_MSG_ARRIVED("调用指令已送达"),
	MID_RESULT_SENT("中间结果已发送"),
	MID_RESULT_RECIEVED("中间结果已接收"),
	MID_RESULT_ARRIVED("中间结果已送达"),
	RESULT_SENT("结果已发送"),
	RESULT_RECIEVED("结果已接收"),
	RESULT_ARRIVED("结果已送达"),
	POST_CALL("异步调用后处理(回调处理)"),
	FINISHED("异步调用处理结束")
	;

	private String desc;

	AsyncProcessPhase(String desc) {
		this.desc = desc;
	}
	
	@Override
	public String toString() {
		return this.desc;
	}
}
