package cn.spatiotemporal.core.async;

import lombok.Getter;
import lombok.Setter;

/**
 * 异步返回值
 * @author marquis
 *
 */
@Getter
@Setter
public class AsyncResult<T> {
	
	/**
	 * 调用ID
	 */
	private long callId;

	/**
	 * 执行状态：成功、失败
	 */
	private boolean success;
	
	/**
	 * 执行阶段
	 */
	private AsyncProcessPhase phase;
	
	/**
	 * 返回信息
	 */
	private String message;
	
	/**
	 * 回调
	 */
	private Callback<T> callback;
	
	public void callback(Callback<T> callback) {
		this.callback = callback;
	}
}
