package cn.spatiotemporal.core.async;

import java.io.Serializable;

import lombok.Getter;
import lombok.Setter;

/**
 * 异步调用 返回值消息体
 * @author marquis
 *
 */
@Getter
@Setter
public class AsyncReturnMessage implements  Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 8106963297158624280L;

	/**
	 * Executor ID执行者的模块ID
	 */
	private String eid;
	
	/**
	 * 异步调用实例ID
	 */
	private String instanceId;
	
	/**
	 * 返回值json
	 */
	private String returnValue;
	
	/**
	 * 调用是否有异常
	 */
	private boolean hasException;
	
	/**
	 * 错误信息
	 */
	private String errorMessage;
}
