package cn.spatiotemporal.core.async.client;

import java.util.function.Consumer;

import lombok.Getter;
import lombok.Setter;

/**
 * 异步调用结果处理（添加成功回调或异常回调）
 * @author marquis
 *
 */
@Setter
@Getter
public class AsyncResult {

	/**
	 * 异步调用实例ID
	 */
	private String instanceId;
	
	/**
	 * 成功回调
	 * @param consumer
	 * @return
	 */
	public <T> AsyncResult onSuccuss(Class<T> clazz, Consumer<T> consumer) {
		AsyncClient.registOnSuccussCallback(instanceId, clazz, consumer);
		return this;
	}

	/**
	 * 异常回调
	 * @param consumer
	 * @return
	 */
	public AsyncResult onFail(Consumer<String> consumer) {
		AsyncClient.registOnFailCallback(instanceId, consumer);
		return this;
	}
}
