package cn.spatiotemporal.core.config;

import javax.annotation.Resource;

import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;

@Configuration
public class DynamicConfig {

	@Resource
	protected Environment environment;
	
	/**
	 * 判断是否存在指定的参数
	 * @param key
	 * @return
	 */
	public boolean containsKey(String key) {
		return environment.containsProperty(key);
	}

	/**
	 * 动态获取配置参数的值(字符串)
	 * @param key
	 * @return
	 */
	public String getValue(String key) {
		return environment.getProperty(key, String.class);
	}

	/**
	 * 动态获取配置参数的值(对象)
	 * @param key
	 * @param clazz
	 * @return
	 */
	public <T> T getValue(String key, Class<T> clazz) {
		return environment.getProperty(key, clazz);
	}

}
