package cn.spatiotemporal.core.config.async;

import org.springframework.amqp.core.Queue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import cn.spatiotemporal.core.async.AsyncConstants;
import cn.spatiotemporal.core.async.spring.EnableAsyncClient;

/**
 * 异步调用配置
 * @author marquis
 *
 */
@Configuration
@ConditionalOnBean(annotation = EnableAsyncClient.class)
public class AsyncClientConfig {
	
	@Autowired
	private String compInstanceId;

    @Bean
    /**
     * 异步调用通讯用MQ
     * @return
     */
    public Queue asyncQueue() {
        Queue queue = new Queue(AsyncConstants.ASYNC_RETURN_MQ + compInstanceId);
        return queue;
    }
    
//    @Bean
//    public DirectExchange asyncReturnExchange() {
//    	DirectExchange exchange = new DirectExchange(AsyncConstants.ASYNC_RABBIT_MQ_EXCHANGE);
//        return exchange;
//    }    
//
//    @Bean
//    public Binding asyncClientBinding(DirectExchange asyncReturnExchange, Queue asyncQueue, String compInstanceId) {
//        //绑定消费规则
//        Binding binding = BindingBuilder.bind(asyncQueue).to(asyncReturnExchange).with(AsyncConstants.ASYNC_RETURN_ROUTING_KEY + compInstanceId);
//        return binding;
//    }
}
