package cn.spatiotemporal.core.config.async;

import org.springframework.amqp.core.Queue;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import cn.spatiotemporal.core.async.AsyncConstants;
import cn.spatiotemporal.core.async.spring.EnableAsyncServer;

/**
 * 异步调用配置
 * @author marquis
 *
 */
@Configuration
@ConditionalOnBean(annotation = EnableAsyncServer.class)
public class AsyncServerConfig {
	
	@Value("${spatiotemporal.async.comp-id}")
	private String compId;
	
	@Bean
	public String compId() {
		return compId;
	}

    @Bean
    /**
     * 异步调用通讯用MQ
     * @return
     */
    public Queue asyncQueue() {
        Queue queue = new Queue(AsyncConstants.ASYNC_CALL_MQ + compId);
        return queue;
    }
    
//    @Bean
//    public DirectExchange asyncCallExchange() {
//    	DirectExchange exchange = new DirectExchange(AsyncConstants.ASYNC_RABBIT_MQ_EXCHANGE);
//        return exchange;
//    }    
//
//    @Bean
//    public Binding asyncServerBinding(DirectExchange asyncCallExchange, Queue asyncQueue, String compId) {
//        //绑定消费规则
//        Binding binding = BindingBuilder.bind(asyncQueue).to(asyncCallExchange).with(AsyncConstants.ASYNC_CALL_ROUTING_KEY + compId);
//        return binding;
//    }
}
