package cn.spatiotemporal.core.env;

import java.util.UUID;

/**
 * 分布式模块的环境参数
 * @author marquis
 *
 */
public class Module {
	
	private final static long instanceId = UUID.randomUUID().getMostSignificantBits();

	/**
	 * 禁止实例化
	 */
	private Module() {
		
	}
	
	/**
	 * 获取分布式模块各自的实例全局唯一ID
	 * 每一个正在运行的模块都有自己的实例ID
	 * @return
	 */
    public static long getInstanceId() {
    	return instanceId;
    }
    
    public static String getHostname() {
    	// TODO 未实现
    	return "";
    };
    
    public static String getIp() {
    	// TODO 未实现
    	return "";
    }
}
